!=======================================================================

SUBROUTINE PRE_NR_COEF1

  USE PRECISION   , ONLY:                                              &
                          WP
  USE CONTROL_DATA, ONLY:                                              &
                          MZ,  DT,                                     &
                          KTTO, KTBO
  USE GRID_MEDIUM , ONLY:                                              &
                          M, DEN, H
  USE NONREF_BOUND, ONLY:                                              &
                          AZ

!-----------------------------------------------------------------------

  IMPLICIT NONE

  REAL (KIND=WP) :: VEL

!-----------------------------------------------------------------------
  
  INTERFACE

    SUBROUTINE     NONREF (H, KEY, VEL,                                &
                           AX01,AX02,AX10,AX11,AX12,AX20,AX21,AX22)
      USE PRECISION, ONLY: WP
      INTEGER,        INTENT (IN)  :: KEY
      REAL (KIND=WP), INTENT (IN)  :: H, VEL
      REAL (KIND=WP), INTENT (OUT) ::                                  &
                           AX01,AX02,AX10,AX11,AX12,AX20,AX21,AX22
    END SUBROUTINE NONREF

  END INTERFACE

!-----------------------------------------------------------------------
!_______________________________________________________ TOP TRANSPARENT
  
  VEL = SQRT( M (0) *H*DEN (0)/DT/DT )

  CALL NONREF ( H,KTTO, VEL,                                           &
                            AZ%ATOP01, AZ%ATOP02,                      &
                 AZ%ATOP10, AZ%ATOP11, AZ%ATOP12,                      &
                 AZ%ATOP20, AZ%ATOP21, AZ%ATOP22  )

!____________________________________________________ BOTTOM TRANSPARENT
  
  VEL = SQRT( M (MZ-1) *H*DEN (MZ)/DT/DT )

  CALL NONREF ( H,KTBO, VEL,                                           &
                            AZ%ABOT01, AZ%ABOT02,                      &
                 AZ%ABOT10, AZ%ABOT11, AZ%ABOT12,                      &
                 AZ%ABOT20, AZ%ABOT21, AZ%ABOT22  )


END SUBROUTINE PRE_NR_COEF1
