!=======================================================================

SUBROUTINE  READ_MODEL_PAR
 
  USE GRID_MEDIUM , ONLY:                                              &
                          H, DEN, M, YM
  USE CONTROL_DATA, ONLY:                                              &
                          DT, MZ, NRFREQ
  USE AUXIL       , ONLY:                                              &
                          G1, G2

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER :: ALLOSTAT, L, J

!-----------------------------------------------------------------------

  ALLOCATE ( DEN ( 0:MZ ),  M ( 0:MZ         ),                        &
                           YM ( 0:MZ, NRFREQ ),         STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR R_M_PAR_01, STAT= ', ALLOSTAT
      STOP
    END IF

  READ  ( 14 ) ( DEN(L),  M (L  ), L = 0, MZ)
  READ  ( 15 ) (         YM (L,:), L = 0, MZ)
  
  DEN  = DT*DT/H/DEN

  DO J = 1, NRFREQ
    YM (:,J) = G2(J) * YM (:,J) * M (:)
  END DO

  DO J = 1, NRFREQ
    M (:) = M (:) + G1(J)* ( YM (:,J) / G2(J) )
  END DO

END SUBROUTINE  READ_MODEL_PAR
