!=======================================================================

SUBROUTINE  AUX1
  USE PRECISION   , ONLY :                                             &
                           WP

  USE GRID_MEDIUM , ONLY :                                             &
                           H

  USE CONTROL_DATA, ONLY :                                             &
                           MZ, DT, FRJMAX, FRANGE, NRFREQ

  USE AUXIL       , ONLY:                                              &
                           PI,                                         &
                           A, B, AH, BH, CH,                           &
                           OTA, OTB, G1, G2
                           
!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER        :: J

  REAL (KIND=WP) :: OH

!-----------------------------------------------------------------------

  AH  = A    /H
  BH  = B    /H
  CH  = 1._WP/H

  ALLOCATE ( OTA(NRFREQ), OTB(NRFREQ), G1(NRFREQ), G2(NRFREQ) )
  
  DO J = 1, NRFREQ
    IF ( FRJMAX == 0. ) THEN
      OH = 0.
    ELSE
      OH=(10**(LOG10(FRJMAX)-(2.*REAL(J)-1.)/REAL(2*NRFREQ)*FRANGE)) *DT *2._WP*PI
    END IF
    OTA (J)= 2._WP*OH /(2._WP+OH)
    OTB (J)=(2._WP-OH)/(2._WP+OH)
    G1  (J)=       OH /(2._WP-OH)
    G2  (J)= 2._WP    /(2._WP-OH)
  END DO
  

END SUBROUTINE  AUX1
