!-----------------------------------------------------------------------
! function returns value of 1/M and RHO as function of coordinate z
!-----------------------------------------------------------------------
FUNCTION FUNC_M1_RHO (Z)

  USE NRTYPE              , ONLY: WP
  USE MOD_FUNC            , ONLY: FUNCV, FUNCRHO

!-----------------------------------------------------------------------

  IMPLICIT NONE

  REAL(WP), INTENT(IN) :: Z
  REAL(WP)             :: FUNC_M1_RHO(2)

  REAL(WP) :: V, RHO, M
  
!-----------------------------------------------------------------------

  V      = FUNCV ( Z )
  RHO    = FUNCRHO( Z )
  M      = RHO * V * V 
  FUNC_M1_RHO (1) = 1._WP / M
  FUNC_M1_RHO (2) = RHO


END FUNCTION FUNC_M1_RHO
