!-----------------------------------------------------------------------
! function returns values of YM as function of coordinate z
!-----------------------------------------------------------------------
FUNCTION FUNC_YM (ZA, NRFREQ)

  USE NRTYPE    , ONLY: WP
  USE MOD_ATTEN , ONLY: PLO, Q, Y, QYLSM
  USE MOD_PARAMETERIZATION                                             &
                , ONLY: Q_OLD, YM_OLD
  USE MOD_FUNC  , ONLY: FUNCQ

!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER , INTENT(IN)            :: NRFREQ
  REAL(WP), INTENT(IN)            :: ZA
  REAL(WP), DIMENSION(NRFREQ)     :: FUNC_YM

  INTEGER                         :: KF
  REAL(WP)                        :: FQ
  REAL(WP), DIMENSION(2*NRFREQ-1) :: HEQ

!----------------------------------------------------------------------

    FQ = FUNCQ(ZA)
 
    IF  ( FQ == Q_OLD ) THEN
      FUNC_YM = YM_OLD
      RETURN
    END IF

    DO KF = 1, 2*NRFREQ-1
      HEQ(KF) = FQ - PLO(KF)
    END DO

    Q   = HEQ
    CALL QYLSM(Q,Y,NRFREQ)

    FUNC_YM (1:NRFREQ) = Y
    Q_OLD = FQ
    YM_OLD  (1:NRFREQ) = Y
    

END FUNCTION FUNC_YM
