!-----------------------------------------------------------------------
! function returns aproximated value of volume integral of field
! FIELD, where volume is line with side H/PTS and center with 
! coordinate (LI)
! note: integral is aproximated by PTS points 
!-----------------------------------------------------------------------
FUNCTION INT1D (LI,FIELD)

  USE NRTYPE         , ONLY: WP
  USE MOD_INTEGRATION, ONLY: PTS, PTS2

!----------------------------------------------------------------------
  
  IMPLICIT NONE

  INTEGER, INTENT(IN)  :: LI
  REAL(WP)             :: INT1D

  REAL(WP), DIMENSION(:), INTENT(INOUT) :: FIELD

  INTEGER              :: L
  REAL(WP)             :: SUM

!----------------------------------------------------------------------

  SUM = 0._WP

  DO L = -PTS2+1, PTS2

    SUM = SUM + FIELD(LI+L)

  END DO

  INT1D = REAL(SUM/PTS, WP)

END FUNCTION INT1D
