!-----------------------------------------------------------------------
! function returns aproximated value of volume integral of field
! FIELD, where volume is line with side H/PTS and center with 
! coordinate (LI)
! note: integral is aproximated by PTS points
!-----------------------------------------------------------------------
FUNCTION INT1D_Y (LI,FIELD,I2NRFREQ1)

  USE NRTYPE         , ONLY: WP
  USE MOD_INTEGRATION, ONLY: PTS, PTS2

!----------------------------------------------------------------------
  
  IMPLICIT NONE

  INTEGER, INTENT(IN)            :: LI, I2NRFREQ1
  REAL(WP), DIMENSION(I2NRFREQ1) :: INT1D_Y

  COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: FIELD

  INTEGER                           :: L
  COMPLEX(WP), DIMENSION(I2NRFREQ1) :: SUM

!----------------------------------------------------------------------

  SUM = (0._WP, 0._WP)

  DO L = -PTS2+1, PTS2

    SUM(:) = SUM(:) + FIELD(LI+L,:)

  END DO

  SUM = REAL(PTS, WP)/SUM

  INT1D_Y = REAL(SUM)/AIMAG(SUM)

END FUNCTION INT1D_Y
