MODULE MOD_INTERFACES

IMPLICIT NONE

INTERFACE

  SUBROUTINE     ALLOCATE_ARRAYS
  END SUBROUTINE ALLOCATE_ARRAYS

  FUNCTION     FUNC_M1_RHO(Z)
    USE NRTYPE              , ONLY: WP
    IMPLICIT NONE
    REAL(WP), INTENT(IN) :: Z
    REAL(WP)             :: FUNC_M1_RHO(2)
  END FUNCTION FUNC_M1_RHO

  FUNCTION     FUNC_YM (ZA, NRFREQ)
    USE NRTYPE    , ONLY: WP
    IMPLICIT NONE
    INTEGER , INTENT(IN)          :: NRFREQ
    REAL(WP), INTENT(IN)          :: ZA
    REAL(WP), DIMENSION(NRFREQ) :: FUNC_YM
  END FUNCTION FUNC_YM

  FUNCTION     INT1D (LI,FIELD)
    USE NRTYPE         , ONLY: WP
    IMPLICIT NONE
    INTEGER, INTENT(IN)  :: LI
    REAL(WP)             :: INT1D
    REAL(WP), DIMENSION(:), INTENT(INOUT) :: FIELD
  END FUNCTION INT1D

  FUNCTION     INT1D_Y (LI,FIELD,I2NRFREQ1)
    USE NRTYPE         , ONLY: WP
    IMPLICIT NONE
    INTEGER, INTENT(IN)            :: LI, I2NRFREQ1
    REAL(WP), DIMENSION(I2NRFREQ1) :: INT1D_Y
    COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: FIELD
  END FUNCTION INT1D_Y

  SUBROUTINE     PREPARE_FINE_PAR (L, H, Z0)
    USE NRTYPE         , ONLY: WP
    IMPLICIT NONE
    INTEGER , INTENT(IN) :: L
    REAL(WP), INTENT(IN) :: H, Z0
  END SUBROUTINE PREPARE_FINE_PAR

  SUBROUTINE     PREPARE_FINE_PAR_Y (L, H, Z0, NRFREQ)
    USE NRTYPE         , ONLY: WP
    IMPLICIT NONE
    INTEGER , INTENT(IN) :: L, NRFREQ
    REAL(WP), INTENT(IN) :: H, Z0
  END SUBROUTINE PREPARE_FINE_PAR_Y

  SUBROUTINE     PRINT_INFO
  END SUBROUTINE PRINT_INFO

  SUBROUTINE     SETPARAMS
  END SUBROUTINE SETPARAMS

  SUBROUTINE     TEST_PARAMETERS
  END SUBROUTINE TEST_PARAMETERS

  SUBROUTINE     WRITE_PARAM
  END SUBROUTINE WRITE_PARAM

END INTERFACE

END MODULE MOD_INTERFACES