MODULE MOD_NR

USE NRTYPE

! module contains procedures from Numerical Recepies
! note: procedures may be slightly modified

IMPLICIT NONE

!-------------------------------------------------------- implementation
CONTAINS

!---------------------------------------------------------------- POLINT
  SUBROUTINE POLINT(XA,YA,X,Y,N)

  IMPLICIT NONE

  INTEGER            :: N, I

  REAL(DP), DIMENSION(:) :: XA, YA
  REAL(DP)               :: X , Y

  Y=0

  IF ( XA(1)<XA(N) ) THEN
    
    DO I = 1, N-1

      IF      ( X == XA(I  ) ) THEN
        Y = YA(I)
        RETURN
      ELSE IF ( X == XA(I+1) ) THEN
        Y = YA(I+1)
        RETURN
      ELSE IF ( X <  XA(I+1) ) THEN
        Y = (YA(I+1)-YA(I))/(XA(I+1)-XA(I))*(X-XA(I))+YA(I)
        RETURN
      END IF

    END DO
  ELSE
    DO I = 1, N-1

      IF      ( X == XA(I  ) ) THEN
        Y = YA(I)
        RETURN
      ELSE IF ( X == XA(I+1) ) THEN
        Y = YA(I+1)
        RETURN
      ELSE IF ( X >  XA(I+1) ) THEN
        Y = (YA(I+1)-YA(I))/(XA(I+1)-XA(I))*(X-XA(I))+YA(I)
        RETURN
      END IF

    END DO
  END IF

  END SUBROUTINE POLINT

END MODULE MOD_NR