!***********************************************************************
! SUBROUTINE PARAMETERIZES GRID
!***********************************************************************
SUBROUTINE PARAMETERIZE_GRID
  
  USE NRTYPE   , ONLY: WP, SP
  USE MOD_ATTEN, ONLY: Q, Y, QYLSM, I2NRFREQ1
  USE MOD_MODEL, ONLY: H, KEY_Q, MZ
  USE MOD_INTEGRATION     , ONLY: PTS, PTS2,                           &
                                  RHO_FINE, M1_FINE,                   &
                                           YM1_FINE
  USE MOD_PARAMETERIZATION, ONLY: CELLS, CELLSY, NRFREQ
  USE MOD_INTERFACES      , ONLY: PREPARE_FINE_PAR, PREPARE_FINE_PAR_Y,&
                                  INT1D, INT1D_Y

!----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER  :: L

  REAL(WP) :: ZA
  
!----------------------------------------------------------------------

  DO L = 0, MZ
    
    ZA =  REAL(L,WP) * H

    CALL   PREPARE_FINE_PAR   (L, H, 0._WP)

    IF (KEY_Q) THEN
      CALL PREPARE_FINE_PAR_Y (L, H, 0._WP, NRFREQ)
    END IF
                                                      !RHO 
    CELLS(L,1) = INT1D ( PTS2, RHO_FINE )
                                                      !M
    CELLS(L,2) = 1._SP / INT1D ( PTS , M1_FINE )

    IF (KEY_Q) THEN

      Q = INT1D_Y ( PTS ,  YM1_FINE , I2NRFREQ1)
      CALL QYLSM(Q,Y,NRFREQ)
      CELLSY(L,1,:) = REAL(Y,SP)

    END IF

	END DO
	

END SUBROUTINE PARAMETERIZE_GRID
