PROGRAM APPQ

  USE PRECISION, ONLY : WP

!----------------------------------------------------------------------

  IMPLICIT NONE

  CHARACTER*20 :: INPUT_FILE_NAME

  INTEGER :: I, J, K, MT, MR, KN, NF, NF1, MR1, MR2

  REAL (KIND=WP)            :: DT, DF, F, DX, CA, DFI, DFIO, QA2

  REAL, DIMENSION(:,:), ALLOCATABLE :: U

  REAL (KIND=WP), PARAMETER :: PI =3.141592654
  REAL (KIND=WP), PARAMETER :: PI2=2*PI

  COMPLEX, DIMENSION(131072):: SSTF1, SSTF2


!----------------------------------------------------------------------

  NAMELIST /INPUT/        MT, DT, DX, INPUT_FILE_NAME

!----------------------------------------------------------------------

  OPEN (11, FILE='APPQ.IN'       , STATUS='OLD')

  READ (11, NML = INPUT  )

  OPEN (10, FILE=INPUT_FILE_NAME , STATUS='OLD')
  OPEN (13, FILE='QAPP.DAT'      , STATUS='NEW')

  MR  = 2
  MR1 = 1
  MR2 = 2
  ALLOCATE ( U(MT,0:MR) )

  DO I = 1, MT
    READ (10, *) ( U(I,K), K = 0, MR )
  END DO

  KN  = 14
  NF  = 2**KN
  DF  = 1./(DT*REAL(NF,WP))
  NF1 = NF/2+1

  DO J = 1, MT
    SSTF1(J) = CMPLX(U(J,MR1),0.)
    SSTF2(J) = CMPLX(U(J,MR2),0.)
  END DO
  DO J = MT+1,NF
    SSTF1(J)=(0.,0.)
    SSTF2(J)=(0.,0.)
  END DO

  CALL FCOOLR(KN,SSTF1,-1.)
  CALL FCOOLR(KN,SSTF2,-1.)

  SSTF1 = SSTF1*DT
  SSTF2 = SSTF2*DT

  DFI = 0.
  K = 0.
  DO J = 2, NF1
    F = REAL(J-1)*DF
    DFIO = DFI
    DFI =   ATAN2 ( AIMAG(SSTF1(J)), REAL(SSTF1(J)) )                  &
           -ATAN2 ( AIMAG(SSTF2(J)), REAL(SSTF2(J)) )
    IF (DFI < 0. ) DFI = DFI + PI2
    DFI = DFI + K*PI2
    IF (ABS(DFI-DFIO)>3./4.*PI) THEN
      K = K+1
      DFI = DFI+PI2
    END IF
    CA  = PI2*F * DX / DFI 
    QA2 = -2.*CA/F/PI2/DX*(LOG(ABS(SSTF2(J)))-LOG(ABS(SSTF1(J))))
    WRITE (13, *) F, 1./QA2, CA
  END DO

  CLOSE ( 10 )
  CLOSE ( 11 )
  CLOSE ( 13 )

END PROGRAM APPQ
