MODULE MOD_FUNC

! module contains functions for P and S-wave velocities, density and
! quality factors in sediments (1st layer)

IMPLICIT NONE

CONTAINS
!==================== 1D INHOMOGENEOUS MEDIUM =========================
!------------------------------------------------- P or S-wave velocity
  FUNCTION FUNCV (Z)

    USE NRTYPE, ONLY: WP

    REAL(WP), INTENT(IN) :: Z
    REAL(WP)             :: FUNCV
    
    funcv = 625.

  END FUNCTION FUNCV

!--------------------------------------------------------------- Density
  FUNCTION FUNCRHO (Z)

    USE NRTYPE, ONLY: WP

    REAL(WP), INTENT(IN) :: Z
    REAL(WP)             :: FUNCRHO

    funcrho = 1600.

  END FUNCTION FUNCRHO

!------------------------------------------- P or S-wave quality factor
  FUNCTION FUNCQ (Z)

    USE NRTYPE, ONLY: WP

    REAL(WP), INTENT(IN) :: Z
    REAL(WP)             :: FUNCQ
  
    funcq = 50.

  END FUNCTION FUNCQ


END MODULE
