Program SVData
!===============================================================================
!
! SVData      is a fortran example for writing data files in format readable
!             by SismoVi  digital signal visualizer
!
!--------------------------------------------------------------------------------
implicit none

real, allocatable :: matrix(:,:)
character(LEN=30)  filename
integer :: i,j,dimX,dimY,nchout

dimX=31
dimY=21

allocate(matrix(dimX,dimY))

do j=1,dimY
    do i=1,dimX
        matrix(i,j)=cos(sqrt(1.0*(i-(dimX+1)/2)**2+(j-(dimY+1)/2)**2)*0.2*3.14159)
    end do
end do

nchout = 200
filename= 'Test1.trace'

OPEN(UNIT=nchout, FILE=filename, FORM='FORMATTED', STATUS='REPLACE')
write(nchout,*) "{"
write(nchout,*) "'title': 'Test 1 data',"
write(nchout,*) "'xlabel':'Time',"
write(nchout,*) "'ylabel':'Space',"
write(nchout,*) "'traces':",dimY,","
write(nchout,*) "'samples':",dimX,","
write(nchout,*) "'tracestep':",1,","
write(nchout,*) "'timestep':",1,","
write(nchout,*) "'data':["
do j=1,dimY
    write(nchout,"(G10.4,2H, )") matrix(1:dimX, j)
end do
write(nchout,*) "]"
write(nchout,*) "}"
CLOSE(nchout)

nchout = 200
filename= 'Test2.trace'

OPEN(UNIT=nchout, FILE=filename, FORM='FORMATTED', STATUS='REPLACE')
write(nchout,*) "{"
write(nchout,*) "'title': 'Test2 data',"
write(nchout,*) "'xlabel':'Time',"
write(nchout,*) "'ylabel':'Space',"
write(nchout,*) "'tracestep':",1,","
write(nchout,*) "'timestep':",1,","
write(nchout,*) "'data':["
do j=1,dimY
    write(nchout,*) "["
    write(nchout,"(G10.4,2H, )") matrix(1:dimX, j)
    write(nchout,*) "]"
    if(j<dimY)write(nchout,*) ","
end do
write(nchout,*) "]"
write(nchout,*) "}"
CLOSE(nchout)

End Program SVData




        
        
        
